#!/bin/sh
# PCP QA Test No. 1383
# Test that indom labels can be created, deleted and rewritten
# by pmlogrewrite(1)
#
# Copyright (c) 2018 Red Hat.  All Rights Reserved.
#

seq=`basename $0`
echo "QA output created by $seq"

# get standard environment, filters and checks
. ./common.product
. ./common.filter
. ./common.check

_cleanup()
{
    cd $here
    $sudo rm -rf $tmp $tmp.*
}

status=1	# failure is the default!
$sudo rm -rf $tmp $tmp.* $seq.full
trap "_cleanup; exit \$status" 0 1 2 3 15

_filter()
{
    tmpx=`echo $tmp`
    sed -e 's/^Archive:.* Host:/ARCHIVE: Host:/' \
	-e "s|$tmpx|TMP|g" \
	-e 's|PID for pmlogger: [0-9]*|PID for pmlogger: PID|'
}

# real QA test starts here
DIR=archives

# First, run pmlogrewrite against the archive, deleting and reassociating some item labels
CONFIG=$tmp.config
cat > $CONFIG << EOF
LABEL INDOM 60.0 {  }
LABEL INDOM 60.0 { DELETE }
LABEL INDOM 60.1 { INDOM -> 60.2 }
EOF
echo contents of $CONFIG >> $seq.full
echo ........................ >> $seq.full
cat $CONFIG >> $seq.full
echo ........................ >> $seq.full
IN=$DIR/20180416.10.00
OUT=$tmp.pmlogrewrite
rm -f $OUT.*
echo "Running pmlogrewrite -c $CONFIG $IN $OUT" | _filter | tee -a $seq.full
pmlogrewrite -c $CONFIG $IN $OUT 2>&1 >> $seq.full
[ $? -eq 0 ] || echo "Error running pmlogrewrite -c $CONFIG $IN $OUT -- see $seq.full"

# Now run pmdumplog against the original and rewritten archives.
DUMP1=$tmp.original.txt
echo "Running pmdumplog -zhide $IN" | _filter | tee -a $seq.full
pmdumplog -zhide $IN 2>&1 > $DUMP1

DUMP2=$tmp.rewritten.txt
IN=$OUT
echo "Running pmdumplog -iteh $IN" | _filter | tee -a $seq.full
pmdumplog -zhide $IN 2>&1 > $DUMP2

# Make sure the item labels have been deleted or reassociated
echo "Running diff $DUMP1 $DUMP2" | _filter | tee -a $seq.full
diff $DUMP1 $DUMP2 2>&1 | _filter | tee -a $seq.full

# Now try creating and rewriting individual labels
cat > $CONFIG << EOF
LABEL INDOM 60.0 "device_type" { LABEL -> "new_device_type" }
LABEL INDOM 60.0 * "cpu" { VALUE -> "new_value" }
LABEL INDOM 60.1 { LABEL -> "new_device_type" }
LABEL INDOM 60.3 { VALUE -> "new_value" }
LABEL INDOM 60.10 * { LABEL -> "new_device_type" }
LABEL INDOM 60.12 * * { VALUE -> "new_value" }

LABEL INDOM 60.17 { NEW "new_indom_label" "new_indom_value" }
LABEL INDOM 60.19 { NEW "new_indom_number" -123.456e+789 }
LABEL INDOM 60.24 { NEW "new_indom_true" true }
LABEL INDOM 60.31 { NEW "new_indom_false" false }
LABEL INDOM 60.32 { NEW "new_indom_null" null }
EOF
echo contents of $CONFIG >> $seq.full
echo ........................ >> $seq.full
cat $CONFIG >> $seq.full
echo ........................ >> $seq.full
IN=$DIR/20180416.10.00
OUT=$tmp.pmlogrewrite
rm -f $OUT.*
echo "Running pmlogrewrite -c $CONFIG $IN $OUT" | _filter | tee -a $seq.full
pmlogrewrite -c $CONFIG $IN $OUT 2>&1 >> $seq.full
[ $? -eq 0 ] || echo "Error running pmlogrewrite -c $CONFIG $IN $OUT -- see $seq.full"

# Now run pmdumplog against the original and rewritten archives.
DUMP1=$tmp.original.txt
echo "Running pmdumplog -zhide $IN" | _filter | tee -a $seq.full
pmdumplog -zhide $IN 2>&1 > $DUMP1

DUMP2=$tmp.rewritten.txt
IN=$OUT
echo "Running pmdumplog -iteh $IN" | _filter | tee -a $seq.full
pmdumplog -zhide $IN 2>&1 > $DUMP2

# Make sure the item labels have been deleted or reassociated
echo "Running diff $DUMP1 $DUMP2" | _filter | tee -a $seq.full
diff $DUMP1 $DUMP2 2>&1 | _filter | tee -a $seq.full

# success, all done
status=0
exit
